const express = require('express');
const app = express();
const PORT   = process.env.PORT || 55315;
const json = require('./original.json');
const bodyParse = require('body-parser');
const fs = require('fs');
const repl = require('repl');


var routes = Object.keys(json).map(function(route){
    return `/${route}`;
});

app.use(bodyParse.urlencoded({extended:true}));
app.use(bodyParse.json());

app.get(routes,function(req, res){
    
    let controller = req.path.replace('/','');

    let size = req.query.size;
    
    let result = json[controller].slice(0,size);

    res.status(200).send(result);
});

app.post(routes,function(req, res){
    var controller =  req.originalUrl.replace('/','');
    json[controller].push(req.body);

    fs.writeFile('original.json',JSON.stringify(json,null,4), (err) => {  
        if (err){
            throw err;
        } 
        res.status(200).send(req.body);
    });

})


app.listen(PORT, function(err){
    if(err){
       console.log(err) 
    }else{
        console.log(`Server running on: http://localhost:${PORT}`);
    }
})